stages:
  - Prepare
  - Build
  - Lint
  - Package

default:
  tags: [ "xxllnc-shared", "arch:x86_64" ]

# Get a new version number and add it as a tag to the commit.
set-version-number-and-tag-commit:
  stage: Prepare
  image: registry.gitlab.com/xxllnc/cloud/xcp-public-charts/tools/semantic_release:1.1.4
  rules:
    - if: '$CI_PIPELINE_SOURCE == "schedule" || $CI_COMMIT_TAG'
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
  script:
    - npx semantic-release

# Build a docker image containing the example application
build-example-application-container-image:
  stage: Build
  image: docker:git
  rules:
    - if: '$CI_PIPELINE_SOURCE == "schedule" || $CI_COMMIT_TAG || $CI_MERGE_REQUEST_ID'
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  script:
    - export VERSION=$(git tag --points-at $CI_COMMIT_SHA)
    - echo $VERSION
    - docker login -u "$CI_REGISTRY_USER" -p "$CI_REGISTRY_PASSWORD" "$CI_REGISTRY"
    - docker buildx build
      --pull
      --output type=registry
      --tag ${CI_REGISTRY_IMAGE}/example-application:$VERSION
      --tag ${CI_REGISTRY_IMAGE}/example-application:latest
      "."

# Lint the helm chart
helm-lint:
  stage: Lint
  image: registry.gitlab.com/xxllnc/cloud/xcp-public-charts/tools/helm-deployment-container:1.1.4
  needs: []
  rules:
    - if: '$CI_PIPELINE_SOURCE == "schedule" || $CI_COMMIT_TAG'
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
    - if: $CI_PIPELINE_SOURCE == "merge_request_event"
  script:
    - helm lint .

# Create a new version of the helm package with the correct chart and app version
helm-package:
  stage: Package
  image: registry.gitlab.com/xxllnc/cloud/xcp-public-charts/tools/helm-deployment-container:1.1.4
  rules:
    - if: '$CI_PIPELINE_SOURCE == "schedule" || $CI_COMMIT_TAG'
      when: never
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
  script:
    - export VERSION=$(git tag --points-at $CI_COMMIT_SHA)
    - echo $VERSION
    - helm package . --version $VERSION
    - 'curl --request POST --user gitlab-ci-token:$CI_JOB_TOKEN --form "chart=@virusscanner-$VERSION.tgz" "${CI_API_V4_URL}/projects/${CI_PROJECT_ID}/packages/helm/api/stable/charts"'